/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.remote;

import android.app.Activity;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.IBinder;

// 定义一个服务类，用于处理Google任务的同步
public class GTaskSyncService extends Service {
    // 定义一个字符串常量，表示同步操作的类型
    public final static String ACTION_STRING_NAME = "sync_action_type";

    // 定义常量，表示开始同步的操作
    public final static int ACTION_START_SYNC = 0;

    // 定义常量，表示取消同步的操作
    public final static int ACTION_CANCEL_SYNC = 1;

    // 定义常量，表示无效的操作
    public final static int ACTION_INVALID = 2;

    // 定义一个广播的名称，用于通知同步状态的变化
    public final static String GTASK_SERVICE_BROADCAST_NAME = "net.micode.notes.gtask.remote.gtask_sync_service";

    // 定义广播的附加数据键，表示是否正在同步
    public final static String GTASK_SERVICE_BROADCAST_IS_SYNCING = "isSyncing";

    // 定义广播的附加数据键，表示同步的进度信息
    public final static String GTASK_SERVICE_BROADCAST_PROGRESS_MSG = "progressMsg";

    // 定义一个异步任务，用于执行同步操作
    private static GTaskASyncTask mSyncTask = null;

    // 定义一个字符串，用于保存同步的进度信息
    private static String mSyncProgress = "";

    // 开始同步的方法
    private void startSync() {
        // 如果当前没有正在执行的同步任务，则创建一个新的异步任务开始同步
        if (mSyncTask == null) {
            mSyncTask = new GTaskASyncTask(this, new GTaskASyncTask.OnCompleteListener() {
                public void onComplete() {
                    // 同步完成后，将异步任务设置为null，发送一个空消息的广播，并停止服务
                    mSyncTask = null;
                    sendBroadcast("");
                    stopSelf();
                }
            });
            sendBroadcast("");
            mSyncTask.execute();
        }
    }

    // 取消同步的方法
    private void cancelSync() {
        // 如果当前有正在执行的同步任务，则取消它
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }

    // 服务创建时调用的方法
    @Override
    public void onCreate() {
        mSyncTask = null;
    }

    // 服务启动时调用的方法
    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        // 从启动服务的Intent中获取附加数据
        Bundle bundle = intent.getExtras();
        if (bundle != null && bundle.containsKey(ACTION_STRING_NAME)) {
            // 根据附加数据中的操作类型，执行相应的操作
            switch (bundle.getInt(ACTION_STRING_NAME, ACTION_INVALID)) {
                case ACTION_START_SYNC:
                    startSync();
                    break;
                case ACTION_CANCEL_SYNC:
                    cancelSync();
                    break;
                default:
                    break;
            }
            return START_STICKY; // 服务被杀死后，系统会尝试重新创建并启动服务
        }
        return super.onStartCommand(intent, flags, startId);
    }

    // 系统内存不足时调用的方法
    @Override
    public void onLowMemory() {
        // 如果当前有正在执行的同步任务，则取消它
        if (mSyncTask != null) {
            mSyncTask.cancelSync();
        }
    }

    // 服务绑定时调用的方法，此处直接返回null，表示不支持绑定
    public IBinder onBind(Intent intent) {
        return null;
    }

    // 发送广播的方法，通知同步状态的变化
    public void sendBroadcast(String msg) {
        mSyncProgress = msg;
        Intent intent = new Intent(GTASK_SERVICE_BROADCAST_NAME);
        intent.putExtra(GTASK_SERVICE_BROADCAST_IS_SYNCING, mSyncTask != null);
        intent.putExtra(GTASK_SERVICE_BROADCAST_PROGRESS_MSG, msg);
        sendBroadcast(intent);
    }

    // 静态方法，用于从Activity中启动同步服务
    public static void startSync(Activity activity) {
        GTaskManager.getInstance().setActivityContext(activity);
        Intent intent = new Intent(activity, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_START_SYNC);
        activity.startService(intent);
    }

    // 静态方法，用于取消同步服务
    public static void cancelSync(Context context) {
        Intent intent = new Intent(context, GTaskSyncService.class);
        intent.putExtra(GTaskSyncService.ACTION_STRING_NAME, GTaskSyncService.ACTION_CANCEL_SYNC);
        context.startService(intent);
    }

    // 静态方法，用于判断当前是否有正在执行的同步任务
    public static boolean isSyncing() {
        return mSyncTask != null;
    }

    // 静态方法，用于获取同步的进度信息
    public static String getProgressString() {
        return mSyncProgress;
    }
}
